// my.cpp : Defines the entry point for the console application.
//
#include "MyStream.h"
#include "math.h"
#include "time.h"
using namespace std;

int f1(int& xmin, int& n1, int& xmax, int& n2, int xx[100]);
int f2(int& xmin, int& n1, int& xmax, int& n2, int* xx, int N1, int N2);
int main()
{  
  myofs.open("protocol.txt");
  myofs << setiosflags(ios::fixed) << setiosflags(ios::right) << setw(10);
  {
  myofs << "Team 123,   . 18  2008 ." << endl; 
  myofs << "  3.  " << endl << endl; 
  }
  {
    myofs << " 1.      mm[8]." << endl;
    int mm[8] = {100, 101, 103, 106, 110, 115, 121, 128};
    myofs << "  mm[8]        ," << endl;
    for(int m=0; m<8; m++){
      myofs << "  mm[" << setw(1) << m << "]=" << setw(4) << mm[m];
      if((m+1)%4==0) myofs << endl;
    }
    myofs << "  <<      , mm=" << mm << endl;
    myofs << "     ,   " << endl;
    myofs << "  *mm=" << *mm << endl;
    myofs << "  *(mm+1)=" << *(mm+1) << endl;
    myofs << "  *(mm+7)=" << *(mm+7) << endl;
    myofs << "     ," << endl;
    mm[1] = 378;
    *(mm+7) = 983;
    myofs << "   *(mm+1)=" << *(mm+1) << endl;
    myofs << "   *(mm+7)=" << *(mm+7) << endl << endl;
  }
  {
    myofs << " 2.       ." << endl;
    int mm2[] = {100, 101, 102, 103, 104};
    myofs << " *(mm2+3)=" << *(mm2+3) << endl;
    double xx2[] = {7.4, 8.5, 9.6, 8.3, 7.1, 4.2};
    myofs << " *(xx2+3)=" << *(xx2+3) << endl << endl;
  }
  {
    myofs << " 3.    xx[100] ( 16 )." << endl;
    const int N=100;
    double xx[N]; 
    for(int m=0; m<N; m++) 
      xx[m]=3.0*sin(double(m)); 
    double x1=0.0, x2=0.0; int count=0;
    for(int m=0; m<16; m++){
      myofs << "  xx[" << setw(2) << m << "]=" << setw(8)<< setprecision(3) << xx[m];
      if((m+1)%4==0) myofs << endl;
    }
    for(int m=0; m<N; m++){
      x1 += xx[m];
      x2 += pow(xx[m], 2);
      count++;
    }
    x1 = x1/double(count);
    x2 = x2/double(count);
    double xave=x1;
    double xdisp=x2-pow(x1,2);
    myofs << "    ." << endl;
    myofs << " <x>=" << setw(10) << setprecision(6) << x1;
    myofs << " <x^2>=" << setw(10) << x2;
    myofs << " <x^2>-<x>^2=" << setw(10) << xdisp << endl << endl;
  }
  {
    myofs << " 4.      ." << endl;
    const int N=1000;
    int xx[N];
    srand((unsigned)time(NULL));
    for(int n=0; n<N; n++) 
      xx[n]=rand()%1024;
    int xmin, xmax, n1, n2;
    f1(xmin, n1, xmax, n2, xx); //  
    myofs << "       100 ." << endl;
    myofs << "  xmin=" << xmin << ",  n1=" << n1;
    myofs << ",  xmax=" << xmax << ",  n2=" << n2 << endl;
    int count = f2(xmin, n1, xmax, n2, xx, 200, 500); //  
    myofs << "       200  499 ." << endl;
    myofs << "  xmin=" << xmin << ",  n1=" << n1;
    myofs << ",  xmax=" << xmax << ",  n2=" << n2 << ",  count=" << count << endl;
  }
  myofs.close();
  return 0;
}
int f1(int& xmi, int& n1, int& xma, int& n2, int xx[100]){
  int x, count=0;
  n1=0, n2=0;
  xmi=xx[0], xma=xx[0];
  for(int n=0; n<100; n++){
      x=xx[n];
      if(x<xmi){xmi=x; n1=n;}
      if(x>xma){xma=x; n2=n;}
      count++;
  }
  return count;
}
int f2(int& xmi, int& n1, int& xma, int& n2, int* xx, int N1, int N2){
  int x, count=0;
  n1=0, n2=0;
  xmi=xx[0], xma=xx[0];
  for(int n=N1; n<N2; n++){
      x=xx[n];
      if(x<xmi){xmi=x; n1=n;}
      if(x>xma){xma=x; n2=n;}
      count++;
  }
  return count;
}

